function gadget:GetInfo()
  return {
    name      = "fog_layer",
    desc      = "draws fog layers",
    author    = "raaar",
    date      = "2018",
    license   = "pd",
    layer     = 0,
    enabled   = true
  }
end

local spGetGameSeconds = Spring.GetGameSeconds
local sin = math.sin
local cos = math.cos
local abs = math.abs
local pi = math.pi

local FOG_ALPHA = 0.2
local FOG_COLOR = {0.5,0.5,0.5}

------------------------------------ SYNCED
if (gadgetHandler:IsSyncedCode()) then


------------------------------------ UNSYNCED
else

function gadget:DrawWorldPreUnit ()  
	drawPlane(70,1,9,3,{-0.3,-0.1})
	drawPlane(90,5,13.3,2.1,{0.3,0.1})
	drawPlane(110,4,11.65,10,{0.13,-0.2})
	drawPlane(130,1.8,15.8,3.3,{0.2,0.3})
	drawPlane(150,7,33.2,4.7,{0.2,-0.2})
	drawPlane(170,2.6,48.7,1.9,{-0.2,0.2})
end


function drawPlane (y,scaleFactor,periodS,tOffset,offsets)
	local t = spGetGameSeconds()
	scaleFactor = scaleFactor * (1+sin(2*pi*(t+tOffset)/periodS) / 15)
	offsetMult = 0.6*(1+sin(2*pi*(t+tOffset)/(0.8*periodS)) / 1)
	
	gl.PushAttrib(GL.ALL_ATTRIB_BITS)
	gl.DepthTest(true)
	gl.DepthMask(true)	
	gl.Texture(0,":a:LuaRules\\Images\\fog.png")-- Texture file	
	gl.Texture(1,":a:LuaRules\\Images\\fog.png")-- Texture file	
	--gl.Color(red,green,blue,alpha)	
	gl.Color(FOG_COLOR[1],FOG_COLOR[2],FOG_COLOR[3],FOG_ALPHA)
	gl.BeginEnd(GL.QUADS,drawPlaneVertexes,  y,scaleFactor, offsets, offsetMult)
	gl.Texture(false)
	gl.DepthMask(false)
	gl.DepthTest(false)	
	gl.PopAttrib()
end



function drawPlaneVertexes (y,scaleFactor, offsets, offsetMult)
  local s = scaleFactor
  local x = Game.mapSizeX
  local z = Game.mapSizeZ
 
--gl.Texture(0,fogtex)
--gl.Texture(1,fogtex)

  gl.MultiTexCoord(0,-s,-s)
  gl.MultiTexCoord(1,-s*2.3,-s*2.3)
  gl.Vertex(-x *(1+offsets[1]*offsetMult),y, -z*(1+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,-s,s)
  gl.MultiTexCoord(1,-s*2.3,s*2.3)
  gl.Vertex(-x*(1+offsets[1]*offsetMult),y,z*(2+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,s,s)
  gl.MultiTexCoord(1,s*2.3,s*2.3)
  gl.Vertex(x*(2+offsets[1]*offsetMult),y,z*(2+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,s,-s)
  gl.MultiTexCoord(1,s*2.3,-s*2.3)
  gl.Vertex(x*(2+offsets[1]*offsetMult),y,-z*(1+offsets[2]*offsetMult))
 
end

end 